<!-- SPDX-License-Identifier: AGPL-3.0-or-later -->
<!-- Copyright (C) 2023 Brennen Chiu -->

{% if in_progress %}
    {% if qr_results and task_status == 'error' and image_error %}
        <div>
            <p class="text-danger">{{ error }}</p>
            <p style="margin-bottom: 0px;">Parsed QR code:</p>
            <ul>
                <li>Test-paper {{ error_paper_id }}</li>
                <li>Page {{ error_page_num }}</li>
                <li>Version {{ error_version_num }}</li>
            </ul>
            <a 
                class="btn btn-success text-start disabled"
                data-bs-toggle="modal"
                data-bs-target="#errorPageChangeModal"
            >
            <i class="bi bi-file-earmark-check"></i>
            Set as valid page image
            </a><br><br>
            <!-- "Set as valid page image" Modal -->
            <div class="modal fade" id="errorPageChangeModal" tabindex="-1" aria-labelledby="errorPageChangeModalLabel" aria-hidden="true">
                <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                    <h5 class="modal-title" id="errorPageChangeModalLabel">Are you sure you would like to change this error page to a valid page?</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-success" hx-post="{% url 'change_error_state' timestamp index %}">Save changes</button>
                    </div>
                </div>
                </div>
            </div>
            <a 
                class="btn btn-warning text-start disabled"
                data-bs-toggle="modal"
                data-bs-target="#replacePageImageModal"
            >
            Replace page image
            </a><br><br>
            <!-- "Replace page image" Modal -->
            <div class="modal fade" id="replacePageImageModal" tabindex="-1" aria-labelledby="replacePageImageModalLabel" aria-hidden="true">
                <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                    <h5 class="modal-title" id="replacePageImageModalLabel">Replace File</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <form
                            enctype="multipart/form-data"
                            method="post"
                            action="{% url 'replace_page_image' timestamp index %}"
                        >
                            {% csrf_token %}
                            {{ replace_image_form }}
                            <div class="modal-footer" style="margin-top: 10px;">
                                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                                <input type="submit" class="btn btn-warning" value="Replace">
                            </div> 
                        </form>
                    </div>
                </div>
                </div>
            </div>
            <a 
                class="btn btn-danger text-start w-100 disabled" 
                data-bs-toggle="modal"
                data-bs-target="#discardPageModal"
            >
            Discard
            </a><br><br>
            <!-- "Discard image" Modal -->
            <div class="modal fade" id="discardPageModal" tabindex="-1" aria-labelledby="discardPageModalLabel" aria-hidden="true">
                <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                    <h5 class="modal-title" id="discardPageModalLabel">Are you sure you would like to discard this page image?</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-danger" hx-post="#">Discard</button>
                    </div>
                </div>
                </div>
            </div>
            {% if not flagged %}
                <form
                    enctype="multipart/form-data"
                    method="post"
                    action="{% url 'scan_flag_img' timestamp index %}"
                >
                {% csrf_token %}
                {{ form }}
        
                <input type="submit" class="btn disabled" style="background-color: lightgrey; width: 100%" value="Flag to manager"> 
                </form>
            {% else %}
                <p>Paper flagged to manager <i class="bi bi-check-circle text-success"></i></p>
            {% endif %}
        </div>
    {% elif qr_results and collision and task_status == 'error' %}
        <div>
            <p class="text-danger">{{ error }}</p>
            <p style="margin-bottom: 0px;">Parsed QR code:</p>
            <ul>
                <li>Test-paper {{ error_paper_id }}</li>
                <li>Page {{ error_page_num }}</li>
                <li>Version {{ error_version_num }}</li>
            </ul>
            <a 
                class="btn btn-success text-start w-100 disabled"
                data-bs-toggle="modal"
                data-bs-target="#collisionPageChangeModal"
            >
            <i class="bi bi-file-earmark-check"></i>
            Keep page
            </a><br><br>
            <!-- "Keep page image" Modal -->
            <div class="modal fade" id="collisionPageChangeModal" tabindex="-1" aria-labelledby="collisionPageChangeModalLabel" aria-hidden="true">
                <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                    <h5 class="modal-title" id="collisionPageChangeModalLabel">Are you sure you would like to keep this page?</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-success" hx-post="{% url 'change_collision_state' timestamp index %}">Keep</button>
                    </div>
                </div>
                </div>
            </div>
            <a 
                class="btn btn-danger text-start w-100 disabled"
                data-bs-toggle="modal"
                data-bs-target="#discardPageModal"
            >
            Discard
            </a><br><br>
            <!-- "Discard page image" Modal -->
            <div class="modal fade" id="discardPageModal" tabindex="-1" aria-labelledby="discardPageModalLabel" aria-hidden="true">
                <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                    <h5 class="modal-title" id="discardPageModalLabel">Are you sure you would like to discard this page?</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-danger" hx-post="{% url 'discard_image' timestamp index %}">Discard</button>
                    </div>
                </div>
                </div>
            </div>
        </div>
    {% elif unknown and task_status == 'error' %}
        <div>
            <p class="text-danger">{{ error }}</p>
        </div>
    {% elif qr_results %}
        <div class="d-flex vstack gap-3">
            <h5 class="text-center">
                <i class="bi bi-check-circle text-success"></i>
                Page QR codes parsed
            </h5>
            <ul>
                <li>Test-paper {{ qr_results.paper_id }}</li>
                <li>Page {{ qr_results.page_num }}</li>
                <li>Version {{ qr_results.version_num }}</li>
            </ul>
        </div>
    {% else %}
        <div hx-get="{% url 'scan_qr_progress' timestamp index %}" hx-trigger="every 1s" hx-swap="outerHTML">
            <div class="d-flex justify-content-center">
            <div class="spinner-border"></div>
        </div>
    </div>
    {% endif %}
{% else %}
<div class="d-flex justify-content-center">
</div>
{% endif %}
